package com.sun.jndi.ldap;

import java.util.StringTokenizer;
import javax.naming.InvalidNameException;
import javax.naming.NotContextException;
import javax.naming.ldap.ExtendedResponse;
import javax.naming.ldap.ExtendedRequest;
import com.sun.jndi.toolkit.dir.SearchFilter;
import javax.naming.directory.SearchResult;
import javax.naming.directory.ModificationItem;
import javax.naming.directory.Attributes;
import javax.naming.NameParser;
import javax.naming.Context;
import javax.naming.Binding;
import javax.naming.directory.SearchControls;
import javax.naming.NameClassPair;
import javax.naming.NamingEnumeration;
import javax.naming.CompositeName;
import javax.naming.ldap.Control;
import java.util.Hashtable;
import javax.naming.NamingException;
import javax.naming.Name;
import javax.naming.ldap.LdapContext;
import javax.naming.directory.DirContext;

final class LdapReferralContext implements DirContext, LdapContext
{
    private DirContext refCtx;
    private Name urlName;
    private String urlAttrs;
    private String urlScope;
    private String urlFilter;
    private LdapReferralException refEx;
    private boolean skipThisReferral;
    private int hopCount;
    private NamingException previousEx;
    
    LdapReferralContext(LdapReferralException p0, Hashtable<?, ?> p1, Control[] p2, Control[] p3, String p4, boolean p5, int p6) throws NamingException {
        // Bytecode:
        // 
        //     4: aload_0        
        //     5: aconst_null    
        //     6: putfield        com/sun/jndi/ldap/LdapReferralContext.refCtx:Ljavax/naming/directory/DirContext;
        //     9: aload_0        
        //    10: aconst_null    
        //    11: putfield        com/sun/jndi/ldap/LdapReferralContext.urlName:Ljavax/naming/Name;
        //    14: aload_0        
        //    15: aconst_null    
        //    16: putfield        com/sun/jndi/ldap/LdapReferralContext.urlAttrs:Ljava/lang/String;
        //    19: aload_0        
        //    20: aconst_null    
        //    21: putfield        com/sun/jndi/ldap/LdapReferralContext.urlScope:Ljava/lang/String;
        //    24: aload_0        
        //    25: aconst_null    
        //    26: putfield        com/sun/jndi/ldap/LdapReferralContext.urlFilter:Ljava/lang/String;
        //    29: aload_0        
        //    30: aconst_null    
        //    31: putfield        com/sun/jndi/ldap/LdapReferralContext.refEx:Lcom/sun/jndi/ldap/LdapReferralException;
        //    34: aload_0        
        //    35: iconst_0       
        //    36: putfield        com/sun/jndi/ldap/LdapReferralContext.skipThisReferral:Z
        //    39: aload_0        
        //    40: iconst_1       
        //    41: putfield        com/sun/jndi/ldap/LdapReferralContext.hopCount:I
        //    44: aload_0        
        //    45: aconst_null    
        //    46: putfield        com/sun/jndi/ldap/LdapReferralContext.previousEx:Ljavax/naming/NamingException;
        //    49: aload_0        
        //    50: aload_1        
        //    51: putfield        com/sun/jndi/ldap/LdapReferralContext.refEx:Lcom/sun/jndi/ldap/LdapReferralException;
        //    54: aload_0        
        //    55: iload           6
        //    57: dup_x1         
        //    58: putfield        com/sun/jndi/ldap/LdapReferralContext.skipThisReferral:Z
        //    61: ifeq            65
        //    64: return         
        //    65: aload_2        
        //    66: ifnull          91
        //    69: aload_2        
        //    70: invokevirtual   java/util/Hashtable.clone:()Ljava/lang/Object;
        //    73: checkcast       Ljava/util/Hashtable;
        //    76: astore_2       
        //    77: aload_3        
        //    78: ifnonnull       104
        //    81: aload_2        
        //    82: ldc             "java.naming.ldap.control.connect"
        //    84: invokevirtual   java/util/Hashtable.remove:(Ljava/lang/Object;)Ljava/lang/Object;
        //    87: pop            
        //    88: goto            104
        //    91: aload_3        
        //    92: ifnull          104
        //    95: new             Ljava/util/Hashtable;
        //    98: dup            
        //    99: iconst_5       
        //   100: invokespecial   java/util/Hashtable.<init>:(I)V
        //   103: astore_2       
        //   104: aload_3        
        //   105: ifnull          134
        //   108: aload_3        
        //   109: arraylength    
        //   110: anewarray       Ljavax/naming/ldap/Control;
        //   113: astore          9
        //   115: aload_3        
        //   116: iconst_0       
        //   117: aload           9
        //   119: iconst_0       
        //   120: aload_3        
        //   121: arraylength    
        //   122: invokestatic    java/lang/System.arraycopy:(Ljava/lang/Object;ILjava/lang/Object;II)V
        //   125: aload_2        
        //   126: ldc             "java.naming.ldap.control.connect"
        //   128: aload           9
        //   130: invokevirtual   java/util/Hashtable.put:(Ljava/lang/Object;Ljava/lang/Object;)Ljava/lang/Object;
        //   133: pop            
        //   134: aload_0        
        //   135: getfield        com/sun/jndi/ldap/LdapReferralContext.refEx:Lcom/sun/jndi/ldap/LdapReferralException;
        //   138: invokevirtual   com/sun/jndi/ldap/LdapReferralException.getNextReferral:()Ljava/lang/String;
        //   141: astore          8
        //   143: aload           8
        //   145: ifnonnull       179
        //   148: aload_0        
        //   149: getfield        com/sun/jndi/ldap/LdapReferralContext.previousEx:Ljavax/naming/NamingException;
        //   152: ifnull          169
        //   155: aload_0        
        //   156: getfield        com/sun/jndi/ldap/LdapReferralContext.previousEx:Ljavax/naming/NamingException;
        //   159: invokevirtual   javax/naming/NamingException.fillInStackTrace:()Ljava/lang/Throwable;
        //   162: checkcast       Ljavax/naming/NamingException;
        //   165: checkcast       Ljavax/naming/NamingException;
        //   168: athrow         
        //   169: new             Ljavax/naming/NamingException;
        //   172: dup            
        //   173: ldc             "Illegal encoding: referral is empty"
        //   175: invokespecial   javax/naming/NamingException.<init>:(Ljava/lang/String;)V
        //   178: athrow         
        //   179: goto            202
        //   182: astore          9
        //   184: iload           7
        //   186: iconst_2       
        //   187: if_icmpne       193
        //   190: aload           9
        //   192: athrow         
        //   193: aload_0        
        //   194: aload           9
        //   196: putfield        com/sun/jndi/ldap/LdapReferralContext.refEx:Lcom/sun/jndi/ldap/LdapReferralException;
        //   199: goto            134
        //   202: new             Ljavax/naming/Reference;
        //   205: dup            
        //   206: ldc             "javax.naming.directory.DirContext"
        //   208: new             Ljavax/naming/StringRefAddr;
        //   211: dup            
        //   212: ldc             "URL"
        //   214: aload           8
        //   216: invokespecial   javax/naming/StringRefAddr.<init>:(Ljava/lang/String;Ljava/lang/String;)V
        //   219: invokespecial   javax/naming/Reference.<init>:(Ljava/lang/String;Ljavax/naming/RefAddr;)V
        //   222: astore          9
        //   224: aload           9
        //   226: aconst_null    
        //   227: aconst_null    
        //   228: aload_2        
        //   229: invokestatic    javax/naming/spi/NamingManager.getObjectInstance:(Ljava/lang/Object;Ljavax/naming/Name;Ljavax/naming/Context;Ljava/util/Hashtable;)Ljava/lang/Object;
        //   232: astore          10
        //   234: goto            280
        //   237: astore          11
        //   239: iload           7
        //   241: iconst_2       
        //   242: if_icmpne       248
        //   245: aload           11
        //   247: athrow         
        //   248: aload_0        
        //   249: aload           11
        //   251: putfield        com/sun/jndi/ldap/LdapReferralContext.previousEx:Ljavax/naming/NamingException;
        //   254: goto            134
        //   257: astore          11
        //   259: new             Ljavax/naming/NamingException;
        //   262: dup            
        //   263: ldc             "problem generating object using object factory"
        //   265: invokespecial   javax/naming/NamingException.<init>:(Ljava/lang/String;)V
        //   268: astore          12
        //   270: aload           12
        //   272: aload           11
        //   274: invokevirtual   javax/naming/NamingException.setRootCause:(Ljava/lang/Throwable;)V
        //   277: aload           12
        //   279: athrow         
        //   280: aload           10
        //   282: instanceof      Ljavax/naming/directory/DirContext;
        //   285: ifeq            337
        //   288: aload_0        
        //   289: aload           10
        //   291: checkcast       Ljavax/naming/directory/DirContext;
        //   294: putfield        com/sun/jndi/ldap/LdapReferralContext.refCtx:Ljavax/naming/directory/DirContext;
        //   297: aload_0        
        //   298: getfield        com/sun/jndi/ldap/LdapReferralContext.refCtx:Ljavax/naming/directory/DirContext;
        //   301: instanceof      Ljavax/naming/ldap/LdapContext;
        //   304: ifeq            326
        //   307: aload           4
        //   309: ifnull          326
        //   312: aload_0        
        //   313: getfield        com/sun/jndi/ldap/LdapReferralContext.refCtx:Ljavax/naming/directory/DirContext;
        //   316: checkcast       Ljavax/naming/ldap/LdapContext;
        //   319: aload           4
        //   321: invokeinterface javax/naming/ldap/LdapContext.setRequestControls:([Ljavax/naming/ldap/Control;)V
        //   326: aload_0        
        //   327: aload           8
        //   329: aload           5
        //   331: invokespecial   com/sun/jndi/ldap/LdapReferralContext.initDefaults:(Ljava/lang/String;Ljava/lang/String;)V
        //   334: goto            386
        //   337: new             Ljavax/naming/NotContextException;
        //   340: dup            
        //   341: new             Ljava/lang/StringBuilder;
        //   344: dup            
        //   345: invokespecial   java/lang/StringBuilder.<init>:()V
        //   348: ldc             "Cannot create context for: "
        //   350: invokevirtual   java/lang/StringBuilder.append:(Ljava/lang/String;)Ljava/lang/StringBuilder;
        //   353: aload           8
        //   355: invokevirtual   java/lang/StringBuilder.append:(Ljava/lang/String;)Ljava/lang/StringBuilder;
        //   358: invokevirtual   java/lang/StringBuilder.toString:()Ljava/lang/String;
        //   361: invokespecial   javax/naming/NotContextException.<init>:(Ljava/lang/String;)V
        //   364: astore          11
        //   366: aload           11
        //   368: new             Ljavax/naming/CompositeName;
        //   371: dup            
        //   372: invokespecial   javax/naming/CompositeName.<init>:()V
        //   375: aload           5
        //   377: invokevirtual   javax/naming/CompositeName.add:(Ljava/lang/String;)Ljavax/naming/Name;
        //   380: invokevirtual   javax/naming/NamingException.setRemainingName:(Ljavax/naming/Name;)V
        //   383: aload           11
        //   385: athrow         
        //   386: return         
        //    Exceptions:
        //  throws javax.naming.NamingException
        //    Signature:
        //  (Lcom/sun/jndi/ldap/LdapReferralException;Ljava/util/Hashtable<**>;[Ljavax/naming/ldap/Control;[Ljavax/naming/ldap/Control;Ljava/lang/String;ZI)V
        //    StackMapTable: 00 10 FF 00 41 00 08 07 00 A6 07 00 A7 07 00 B0 07 00 A4 07 00 A4 07 00 AD 01 01 00 00 19 0C 1D FC 00 22 07 00 AD 09 FF 00 02 00 08 07 00 A6 07 00 A7 07 00 B0 07 00 A4 07 00 A4 07 00 AD 01 01 00 01 07 00 A7 FD 00 0A 00 07 00 A7 FF 00 08 00 09 07 00 A6 07 00 A7 07 00 B0 07 00 A4 07 00 A4 07 00 AD 01 01 07 00 AD 00 00 FF 00 22 00 0A 07 00 A6 07 00 A7 07 00 B0 07 00 A4 07 00 A4 07 00 AD 01 01 07 00 AD 07 00 B8 00 01 07 00 B6 FD 00 0A 00 07 00 B6 FF 00 08 00 0A 07 00 A6 07 00 A7 07 00 B0 07 00 A4 07 00 A4 07 00 AD 01 01 07 00 AD 07 00 B8 00 01 07 00 AB FC 00 16 07 00 AC 2D 0A F9 00 30
        //    Exceptions:
        //  Try           Handler
        //  Start  End    Start  End    Type                                     
        //  -----  -----  -----  -----  -----------------------------------------
        //  134    179    182    202    Lcom/sun/jndi/ldap/LdapReferralException;
        //  224    234    237    257    Ljavax/naming/NamingException;
        //  224    234    257    280    Ljava/lang/Exception;
        // 
        throw new IllegalStateException("An error occurred while decompiling this method.");
    }
    
    private void initDefaults(String s, String s2) throws NamingException {
        String dn;
        try {
            LdapURL ldapURL = new LdapURL(s);
            dn = ldapURL.getDN();
            this.urlAttrs = ldapURL.getAttributes();
            this.urlScope = ldapURL.getScope();
            this.urlFilter = ldapURL.getFilter();
        }
        catch (NamingException ex) {
            dn = s;
            String urlAttrs = null;
            this.urlFilter = urlAttrs;
            this.urlScope = urlAttrs;
            this.urlAttrs = urlAttrs;
        }
        String comp;
        if (dn == null) {
            comp = s2;
        }
        else {
            comp = "";
        }
        if (comp == null) {
            this.urlName = null;
        }
        else {
            this.urlName = (comp.equals("") ? new CompositeName() : new CompositeName().add(comp));
        }
    }
    
    @Override
    public void close() throws NamingException {
        if (this.refCtx != null) {
            this.refCtx.close();
            this.refCtx = null;
        }
        this.refEx = null;
    }
    
    void setHopCount(int n) {
        this.hopCount = n;
        if (this.refCtx != null && this.refCtx instanceof LdapCtx) {
            ((LdapCtx)this.refCtx).setHopCount(n);
        }
    }
    
    @Override
    public Object lookup(String s) throws NamingException {
        return this.lookup(this.toName(s));
    }
    
    @Override
    public Object lookup(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.lookup(this.overrideName(name));
    }
    
    @Override
    public void bind(String s, Object o) throws NamingException {
        this.bind(this.toName(s), o);
    }
    
    @Override
    public void bind(Name name, Object o) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.bind(this.overrideName(name), o);
        return;
    }
    
    @Override
    public void rebind(String s, Object o) throws NamingException {
        this.rebind(this.toName(s), o);
    }
    
    @Override
    public void rebind(Name name, Object o) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.rebind(this.overrideName(name), o);
        return;
    }
    
    @Override
    public void unbind(String s) throws NamingException {
        this.unbind(this.toName(s));
    }
    
    @Override
    public void unbind(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.unbind(this.overrideName(name));
        return;
    }
    
    @Override
    public void rename(String s, String s2) throws NamingException {
        this.rename(this.toName(s), this.toName(s2));
    }
    
    @Override
    public void rename(Name name, Name name2) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.rename(this.overrideName(name), this.toName(this.refEx.getNewRdn()));
        return;
    }
    
    @Override
    public NamingEnumeration<NameClassPair> list(String s) throws NamingException {
        return this.list(this.toName(s));
    }
    
    @Override
    public NamingEnumeration<NameClassPair> list(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        try {
            NamingEnumeration namingEnumeration;
            if (this.urlScope != null && this.urlScope.equals("base")) {
                SearchControls searchControls = new SearchControls();
                searchControls.setReturningObjFlag(true);
                searchControls.setSearchScope(0);
                namingEnumeration = this.refCtx.search(this.overrideName(name), "(objectclass=*)", searchControls);
            }
            else {
                namingEnumeration = this.refCtx.list(this.overrideName(name));
            }
            this.refEx.setNameResolved(true);
            ((ReferralEnumeration)namingEnumeration).appendUnprocessedReferrals(this.refEx);
            return namingEnumeration;
        }
        catch (LdapReferralException ex) {
            ex.appendUnprocessedReferrals(this.refEx);
            throw (NamingException)(NamingException)ex.fillInStackTrace();
        }
        catch (NamingException namingException) {
            if (this.refEx != null && !this.refEx.hasMoreReferrals()) {
                this.refEx.setNamingException(namingException);
            }
            if (this.refEx != null && (this.refEx.hasMoreReferrals() || this.refEx.hasMoreReferralExceptions())) {
                throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
            }
            throw namingException;
        }
    }
    
    @Override
    public NamingEnumeration<Binding> listBindings(String s) throws NamingException {
        return this.listBindings(this.toName(s));
    }
    
    @Override
    public NamingEnumeration<Binding> listBindings(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        try {
            NamingEnumeration namingEnumeration;
            if (this.urlScope != null && this.urlScope.equals("base")) {
                SearchControls searchControls = new SearchControls();
                searchControls.setReturningObjFlag(true);
                searchControls.setSearchScope(0);
                namingEnumeration = this.refCtx.search(this.overrideName(name), "(objectclass=*)", searchControls);
            }
            else {
                namingEnumeration = this.refCtx.listBindings(this.overrideName(name));
            }
            this.refEx.setNameResolved(true);
            ((ReferralEnumeration)namingEnumeration).appendUnprocessedReferrals(this.refEx);
            return namingEnumeration;
        }
        catch (LdapReferralException ex) {
            ex.appendUnprocessedReferrals(this.refEx);
            throw (NamingException)(NamingException)ex.fillInStackTrace();
        }
        catch (NamingException namingException) {
            if (this.refEx != null && !this.refEx.hasMoreReferrals()) {
                this.refEx.setNamingException(namingException);
            }
            if (this.refEx != null && (this.refEx.hasMoreReferrals() || this.refEx.hasMoreReferralExceptions())) {
                throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
            }
            throw namingException;
        }
    }
    
    @Override
    public void destroySubcontext(String s) throws NamingException {
        this.destroySubcontext(this.toName(s));
    }
    
    @Override
    public void destroySubcontext(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.destroySubcontext(this.overrideName(name));
        return;
    }
    
    @Override
    public Context createSubcontext(String s) throws NamingException {
        return this.createSubcontext(this.toName(s));
    }
    
    @Override
    public Context createSubcontext(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.createSubcontext(this.overrideName(name));
    }
    
    @Override
    public Object lookupLink(String s) throws NamingException {
        return this.lookupLink(this.toName(s));
    }
    
    @Override
    public Object lookupLink(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.lookupLink(this.overrideName(name));
    }
    
    @Override
    public NameParser getNameParser(String s) throws NamingException {
        return this.getNameParser(this.toName(s));
    }
    
    @Override
    public NameParser getNameParser(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.getNameParser(this.overrideName(name));
    }
    
    @Override
    public String composeName(String s, String s2) throws NamingException {
        return this.composeName(this.toName(s), this.toName(s2)).toString();
    }
    
    @Override
    public Name composeName(Name name, Name name2) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.composeName(name, name2);
    }
    
    @Override
    public Object addToEnvironment(String s, Object o) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.addToEnvironment(s, o);
    }
    
    @Override
    public Object removeFromEnvironment(String s) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.removeFromEnvironment(s);
    }
    
    @Override
    public Hashtable<?, ?> getEnvironment() throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.getEnvironment();
    }
    
    @Override
    public Attributes getAttributes(String s) throws NamingException {
        return this.getAttributes(this.toName(s));
    }
    
    @Override
    public Attributes getAttributes(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.getAttributes(this.overrideName(name));
    }
    
    @Override
    public Attributes getAttributes(String s, String[] array) throws NamingException {
        return this.getAttributes(this.toName(s), array);
    }
    
    @Override
    public Attributes getAttributes(Name name, String[] array) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.getAttributes(this.overrideName(name), array);
    }
    
    @Override
    public void modifyAttributes(String s, int n, Attributes attributes) throws NamingException {
        this.modifyAttributes(this.toName(s), n, attributes);
    }
    
    @Override
    public void modifyAttributes(Name name, int n, Attributes attributes) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.modifyAttributes(this.overrideName(name), n, attributes);
        return;
    }
    
    @Override
    public void modifyAttributes(String s, ModificationItem[] array) throws NamingException {
        this.modifyAttributes(this.toName(s), array);
    }
    
    @Override
    public void modifyAttributes(Name name, ModificationItem[] array) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.modifyAttributes(this.overrideName(name), array);
        return;
    }
    
    @Override
    public void bind(String s, Object o, Attributes attributes) throws NamingException {
        this.bind(this.toName(s), o, attributes);
    }
    
    @Override
    public void bind(Name name, Object o, Attributes attributes) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.bind(this.overrideName(name), o, attributes);
        return;
    }
    
    @Override
    public void rebind(String s, Object o, Attributes attributes) throws NamingException {
        this.rebind(this.toName(s), o, attributes);
    }
    
    @Override
    public void rebind(Name name, Object o, Attributes attributes) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        this.refCtx.rebind(this.overrideName(name), o, attributes);
        return;
    }
    
    @Override
    public DirContext createSubcontext(String s, Attributes attributes) throws NamingException {
        return this.createSubcontext(this.toName(s), attributes);
    }
    
    @Override
    public DirContext createSubcontext(Name name, Attributes attributes) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.createSubcontext(this.overrideName(name), attributes);
    }
    
    @Override
    public DirContext getSchema(String s) throws NamingException {
        return this.getSchema(this.toName(s));
    }
    
    @Override
    public DirContext getSchema(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.getSchema(this.overrideName(name));
    }
    
    @Override
    public DirContext getSchemaClassDefinition(String s) throws NamingException {
        return this.getSchemaClassDefinition(this.toName(s));
    }
    
    @Override
    public DirContext getSchemaClassDefinition(Name name) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return this.refCtx.getSchemaClassDefinition(this.overrideName(name));
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(String s, Attributes attrs) throws NamingException {
        return this.search(this.toName(s), SearchFilter.format(attrs), new SearchControls());
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(Name name, Attributes attrs) throws NamingException {
        return this.search(name, SearchFilter.format(attrs), new SearchControls());
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(String s, Attributes attrs, String[] returningAttributes) throws NamingException {
        SearchControls searchControls = new SearchControls();
        searchControls.setReturningAttributes(returningAttributes);
        return this.search(this.toName(s), SearchFilter.format(attrs), searchControls);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(Name name, Attributes attrs, String[] returningAttributes) throws NamingException {
        SearchControls searchControls = new SearchControls();
        searchControls.setReturningAttributes(returningAttributes);
        return this.search(name, SearchFilter.format(attrs), searchControls);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(String s, String s2, SearchControls searchControls) throws NamingException {
        return this.search(this.toName(s), s2, searchControls);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(Name name, String s, SearchControls searchControls) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        try {
            NamingEnumeration<SearchResult> search = this.refCtx.search(this.overrideName(name), this.overrideFilter(s), this.overrideAttributesAndScope(searchControls));
            this.refEx.setNameResolved(true);
            ((ReferralEnumeration)search).appendUnprocessedReferrals(this.refEx);
            return search;
        }
        catch (LdapReferralException ex) {
            ex.appendUnprocessedReferrals(this.refEx);
            throw (NamingException)(NamingException)ex.fillInStackTrace();
        }
        catch (NamingException namingException) {
            if (this.refEx != null && !this.refEx.hasMoreReferrals()) {
                this.refEx.setNamingException(namingException);
            }
            if (this.refEx != null && (this.refEx.hasMoreReferrals() || this.refEx.hasMoreReferralExceptions())) {
                throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
            }
            throw namingException;
        }
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(String s, String s2, Object[] array, SearchControls searchControls) throws NamingException {
        return this.search(this.toName(s), s2, array, searchControls);
    }
    
    @Override
    public NamingEnumeration<SearchResult> search(Name name, String s, Object[] array, SearchControls searchControls) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        try {
            NamingEnumeration<SearchResult> namingEnumeration;
            if (this.urlFilter != null) {
                namingEnumeration = this.refCtx.search(this.overrideName(name), this.urlFilter, this.overrideAttributesAndScope(searchControls));
            }
            else {
                namingEnumeration = this.refCtx.search(this.overrideName(name), s, array, this.overrideAttributesAndScope(searchControls));
            }
            this.refEx.setNameResolved(true);
            ((ReferralEnumeration)namingEnumeration).appendUnprocessedReferrals(this.refEx);
            return namingEnumeration;
        }
        catch (LdapReferralException ex) {
            ex.appendUnprocessedReferrals(this.refEx);
            throw (NamingException)(NamingException)ex.fillInStackTrace();
        }
        catch (NamingException namingException) {
            if (this.refEx != null && !this.refEx.hasMoreReferrals()) {
                this.refEx.setNamingException(namingException);
            }
            if (this.refEx != null && (this.refEx.hasMoreReferrals() || this.refEx.hasMoreReferralExceptions())) {
                throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
            }
            throw namingException;
        }
    }
    
    @Override
    public String getNameInNamespace() throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        return (this.urlName != null && !this.urlName.isEmpty()) ? this.urlName.get(0) : "";
    }
    
    @Override
    public ExtendedResponse extendedOperation(ExtendedRequest extendedRequest) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        if (!(this.refCtx instanceof LdapContext)) {
            throw new NotContextException("Referral context not an instance of LdapContext");
        }
        return ((LdapContext)this.refCtx).extendedOperation(extendedRequest);
    }
    
    @Override
    public LdapContext newInstance(Control[] array) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        if (!(this.refCtx instanceof LdapContext)) {
            throw new NotContextException("Referral context not an instance of LdapContext");
        }
        return ((LdapContext)this.refCtx).newInstance(array);
    }
    
    @Override
    public void reconnect(Control[] array) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        if (!(this.refCtx instanceof LdapContext)) {
            throw new NotContextException("Referral context not an instance of LdapContext");
        }
        ((LdapContext)this.refCtx).reconnect(array);
        return;
    }
    
    @Override
    public Control[] getConnectControls() throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        if (!(this.refCtx instanceof LdapContext)) {
            throw new NotContextException("Referral context not an instance of LdapContext");
        }
        return ((LdapContext)this.refCtx).getConnectControls();
    }
    
    @Override
    public void setRequestControls(Control[] requestControls) throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        if (!(this.refCtx instanceof LdapContext)) {
            throw new NotContextException("Referral context not an instance of LdapContext");
        }
        ((LdapContext)this.refCtx).setRequestControls(requestControls);
        return;
    }
    
    @Override
    public Control[] getRequestControls() throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        if (!(this.refCtx instanceof LdapContext)) {
            throw new NotContextException("Referral context not an instance of LdapContext");
        }
        return ((LdapContext)this.refCtx).getRequestControls();
    }
    
    @Override
    public Control[] getResponseControls() throws NamingException {
        if (this.skipThisReferral) {
            throw (NamingException)(NamingException)this.refEx.appendUnprocessedReferrals(null).fillInStackTrace();
        }
        if (!(this.refCtx instanceof LdapContext)) {
            throw new NotContextException("Referral context not an instance of LdapContext");
        }
        return ((LdapContext)this.refCtx).getResponseControls();
    }
    
    private Name toName(String comp) throws InvalidNameException {
        return comp.equals("") ? new CompositeName() : new CompositeName().add(comp);
    }
    
    private Name overrideName(Name name) throws InvalidNameException {
        return (this.urlName == null) ? name : this.urlName;
    }
    
    private SearchControls overrideAttributesAndScope(SearchControls searchControls) {
        if (this.urlScope != null || this.urlAttrs != null) {
            SearchControls searchControls2 = new SearchControls(searchControls.getSearchScope(), searchControls.getCountLimit(), searchControls.getTimeLimit(), searchControls.getReturningAttributes(), searchControls.getReturningObjFlag(), searchControls.getDerefLinkFlag());
            if (this.urlScope != null) {
                if (this.urlScope.equals("base")) {
                    searchControls2.setSearchScope(0);
                }
                else if (this.urlScope.equals("one")) {
                    searchControls2.setSearchScope(1);
                }
                else if (this.urlScope.equals("sub")) {
                    searchControls2.setSearchScope(2);
                }
            }
            if (this.urlAttrs != null) {
                StringTokenizer stringTokenizer = new StringTokenizer(this.urlAttrs, ",");
                int countTokens = stringTokenizer.countTokens();
                String[] returningAttributes = new String[countTokens];
                for (int i = 0; i < countTokens; ++i) {
                    returningAttributes[i] = stringTokenizer.nextToken();
                }
                searchControls2.setReturningAttributes(returningAttributes);
                return searchControls2;
            }
            return searchControls2;
        }
        else {
            return searchControls;
        }
    }
    
    private String overrideFilter(String s) {
        return (this.urlFilter == null) ? s : this.urlFilter;
    }
}
